Subject: ActionRequest does not resolve correctly cased package key
Description

The methods createPackage in class TYPO3\Flow\Package\PackageManage no longers generates the Package.php. The
kickstart:package command uses this methods when kickstarting new packages, and the missing Package.php lead to seemingly
unrelated errors like not not being able to correctly translate lower-case packagename to correct packagename.

I'm not sure why the file is no longer generated, it seems to be in relation to the Composer changes of the PackageManager, and it
might very well be by intention.

If its by intention, we need to change the setControllerPackageKey of ActionRequest, since it calls the
ObjectManger->getCaseSensitiveObjectName looking for the Package class, which when missing fails to find the correct
PackageKey.

Anyone knows if its by intention it was omitted from the packagemanager?

Related issues:
related to TYPO3 Flow Base Distribution - Story # 41031: Composer support for... Resolved 2012-09-17

Associated revisions
Revision b744c359 - 2012-10-09 09:36 - Jan-Erik Revsbech 

[BUGFIX] ActionRequest does not resolve correctly cased package key

ActionRequest resolves lowercased package key by looking for
Package class instead of asking PackageManager. If no Package class
exists in the given Package, the request fails.

Resolves: #41657
Releases: 1.2
Change-Id: I5dd4e4e251f77dd104f0fcedfd4f9af852b368c3

History
#1 - 2012-10-08 13:35 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15396
#2 - 2012-10-08 14:01 - Jan-Erik Revsbech

It seems to be intentional that the Package.php is not generated.

If the Package.php class i optional, then I think its an error that setControllerPackageKey on the ActionRequest uses uses
ObjectManager->getCaseSensitiveObjectName to retrieve the actual package key, or am I totally missing something?

public function setControllerPackageKey($packageKey) {
   $upperCamelCasedPackageClassName = $this->objectManager->getCaseSensitiveObjectName(str_replace('.', '\\', $packageKey) .
'\Package');
   $this->controllerPackageKey = ($upperCamelCasedPackageClassName !== FALSE) ? substr(str_replace('\\', '.',
$upperCamelCasedPackageClassName), 0, strlen($packageKey)) : $packageKey;
 }

#3 - 2012-10-08 15:04 - Christopher Hlubek
- Priority changed from Should have to Must have

Yes, it seems like the usage of getCaseSensitiveObjectName always expects a class named Package. We have to fix this behavior and use the
correction of the package key inside the PackageManager (getCaseSensitivePackageKey).

Jan-Erik Revsbech wrote:

It seems to be intentional that the Package.php is not generated.

If the Package.php class i optional, then I think its an error that setControllerPackageKey on the ActionRequest uses uses
ObjectManager->getCaseSensitiveObjectName to retrieve the actual package key, or am I totally missing something?

public function setControllerPackageKey($packageKey) {
$upperCamelCasedPackageClassName = $this->objectManager->getCaseSensitiveObjectName(str_replace('.', '\\', $packageKey) . '\Package');
$this->controllerPackageKey = ($upperCamelCasedPackageClassName !== FALSE) ? substr(str_replace('\\', '.',
$upperCamelCasedPackageClassName), 0, strlen($packageKey)) : $packageKey;
}

#4 - 2012-10-08 15:06 - Christopher Hlubek
- Subject changed from PackageManager->createPackage does not create Package.php file to ActionRequest does not resolve correctly cased 
package key

#5 - 2012-10-08 21:11 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15396

#6 - 2012-10-08 21:14 - Jan-Erik Revsbech

Christopher Hlubek wrote:

Yes, it seems like the usage of getCaseSensitiveObjectName always expects a class named Package. We have to fix this behavior and use the
correction of the package key inside the PackageManager (getCaseSensitivePackageKey).
I submitted a patch set correcting the behaviour of the ActionRequest. I was unaware of the getCaseSensitivePackageKey method of the
PackageManager.

#7 - 2012-10-09 08:24 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15396

#8 - 2012-10-09 09:06 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15396

#9 - 2012-10-09 09:36 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/15396

#10 - 2012-10-09 10:35 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:b744c359a9ff0373a5c22926cf3577468bbe952e.

#11 - 2012-11-12 09:50 - Karsten Dambekalns
- Assigned To set to Jan-Erik Revsbech
